# from pyfbsdk import FBModelList, FBGetSelectedModels, FBVector3d, FBMessageBox, FBTime
from pyfbsdk import *
from pyfbsdk_additions import *

toolname = "Plot Curve from Animation"

#Development? - need to recreate each time!!
gDEVELOPMENT = False

# global start
# global end
# global step

start = 0
end = 100
step = 1

def ChgToCurve(control, event):
    global start
    global end
    global step
    Player = FBPlayerControl()
    lSelectedModels = FBModelList()
    FBGetSelectedModels( lSelectedModels )

## This script will reset all the local translation and rotation on selected model
    if len(lSelectedModels)==0:
        FBMessageBox("Reset Local Translation and Rotation on selected objects", "No model selected, no operation performed...", "Ok")
    else:
        for lModel in lSelectedModels:
            print lModel.Name
#           print lModel.Translation
            pNode = lModel.AnimationNode
#           print pNode.Name
            fcurve = pNode.FCurve
#           print fcurve
            counter = 0

            path = FBModelPath3D("AnmPath_"+lModel.Name)
            path.Show = True
            path.ShowCurveControls(1)
            path.ShowCurvePoints(1)

            evalframe = start
            path.PathKeyRemove(1)

            while evalframe <= end:
#                print evalframe
                frameTime = FBTime(0,0,0,int(evalframe))
                Player.Goto(frameTime)

                xx = lModel.Translation[0]
                yy = lModel.Translation[1]
                zz = lModel.Translation[2]
                if counter == 0:
                    path.PathKeySet(0,FBVector4d(xx,yy,zz,1))
                else:
                    path.PathKeyEndAdd(FBVector4d(xx,yy,zz,1))

                evalframe = evalframe + step
                counter = counter + 1

def ChgStart(control, event):
    global start
    start = control.Value

def ChgEnd(control, event):
    global end
    end = control.Value

def ChgStep(control, event):
    global step
    step = control.Value

def BuildUI (mainLyt):
    global start
    global end
    global step
    anchor = ""
    attachType = FBAttachType.kFBAttachTop

# Add Start
    labId = "Start"
    x = FBAddRegionParam(10,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(10,attachType,anchor)
    w = FBAddRegionParam(40,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(labId,labId, x, y, w, h)

    lStLabel = FBLabel()
    lStLabel.Caption = "Start"
    mainLyt.SetControl(labId,lStLabel)

    editId = "EditStart"
    x = FBAddRegionParam(10,FBAttachType.kFBAttachRight,labId)
    y = FBAddRegionParam(10,attachType,anchor)
    w = FBAddRegionParam(150,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(editId,editId, x, y, w, h)

    lStart = FBEditNumber()
    mainLyt.SetControl(editId,lStart)
    lStart.Value = start
    lStart.OnChange.Add(ChgStart)

    attachType = FBAttachType.kFBAttachBottom
    anchor = labId

# Add End
    labId = "End"
    x = FBAddRegionParam(10,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(10,attachType,anchor)
    w = FBAddRegionParam(40,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(labId,labId, x, y, w, h)

    lEdLabel = FBLabel()
    lEdLabel.Caption = "End"
    mainLyt.SetControl(labId,lEdLabel)

    editId = "EditEnd"
    x = FBAddRegionParam(10,FBAttachType.kFBAttachRight,labId)
    y = FBAddRegionParam(10,attachType,anchor)
    w = FBAddRegionParam(150,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(editId,editId, x, y, w, h)

    lEnd = FBEditNumber()
    mainLyt.SetControl(editId,lEnd)
    # Set Default
    lEnd.Value = end
    lEnd.OnChange.Add(ChgEnd)

    attachType = FBAttachType.kFBAttachBottom
    anchor = labId

# Add Step
    labId = "Step"
    x = FBAddRegionParam(10,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(10,attachType,anchor)
    w = FBAddRegionParam(40,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(labId,labId, x, y, w, h)

    lSeLabel = FBLabel()
    lSeLabel.Caption = "Step"
    mainLyt.SetControl(labId,lSeLabel)

    editId = "EditStep"
    x = FBAddRegionParam(10,FBAttachType.kFBAttachRight,labId)
    y = FBAddRegionParam(10,attachType,anchor)
    w = FBAddRegionParam(150,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(editId,editId, x, y, w, h)

    lStep = FBEditNumber()
    mainLyt.SetControl(editId,lStep)
    # Set Default
    lStep.Value = step
    lStep.OnChange.Add(ChgStep)

    attachType = FBAttachType.kFBAttachBottom
    anchor = labId

    #
    # Add our Plot button
    #
    labId = "button"
    x = FBAddRegionParam(-72,FBAttachType.kFBAttachRight,"")
    y = FBAddRegionParam(-30,FBAttachType.kFBAttachBottom,"")
    w = FBAddRegionParam(70,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    mainLyt.AddRegion(labId,labId, x, y, w, h)

    lButton = FBButton()
    lButton.Caption = "Plot"
    lButton.Justify = FBTextJustify.kFBTextJustifyCenter
    mainLyt.SetControl(labId,lButton)
    lButton.OnClick.Add(ChgToCurve)

def CreateTool_Plot():
    # Tool creation will serve as the hub for all other controls
    t = FBCreateUniqueTool(toolname)
    t.StartSizeX = 350
    t.StartSizeY = 170
    BuildUI(t)
    return t

if gDEVELOPMENT:
    FBDestroyToolByName(toolname)

if toolname in FBToolList:
    tool = FBToolList[toolname]
    ShowTool(tool)
else:
    tool=CreateTool_Plot()
    if gDEVELOPMENT:
        ShowTool(tool)



